#!/usr/bin/env python
"""
Command line utility to dump the ASCII or EBCDIC

     Copyright (C) 2005  Kurt Schwehr

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$Id: segytextheader.py,v 1.1 2005/09/10 20:43:19 schwehr Exp $

"""

# These values end up in the pydoc web page
__version__ = '$Revision: 1.1 $' # See man ident
__date__ = '$Date: 2005/09/10 20:43:19 $' # FIX: pull out just the date
__author__ = 'Kurt Schwehr'
__credits__ = """Nothing happens in a vacuum"""

from segy import Segy
import segy
import sqlite
import os
import sys

from optparse import OptionParser

# What version do we want to track?  This would be for cvs of this file
vcvs = "$Revision: 1.1 $"
vcvs = vcvs[vcvs.find(':')+2:]
vcvs = vcvs[:vcvs.find('$')-1]
version_cvs = vcvs
del (vcvs) # stop polution

# Track the version of segy-py.  If I use setup.py, which one gets imported?
from segy_version import VERSION

myparser = OptionParser(usage="%prog [options] segyfile1 segyfile2 ... segyfileN",
                      version="%prog "+VERSION+' - '+version_cvs)
myparser.add_option('-e','--ebcdic',dest='ebcdic',action="store_true",default=False,
		    help='')
myparser.add_option('-d','--driver',dest="drv",
                  help="specify which driver to parse data file.  [default: %default]",
                  default="segy_drv_rev1")

BOMBASTIC= 4
VERBOSE  = 3
TRACE    = 2
TERSE    = 1
ALWAYS   = 0

myparser.add_option('-v','--verbose',action="count",dest='verbosity',default=0,
                    help='how information to give.  Specify multiple times to increase verbosity')
myparser.add_option('--verbosity',dest='verbosity',type='int',
                    help='Specify verbosity.  Should be in the range of '
                    +str(ALWAYS)+'...'+str(BOMBASTIC)+' (None...Bombastic)')

myparser.add_option('-w','--warn-only',action="store_true",dest='warnOnly',default=False,
                    help='Allow processing to continue in certain error conditions. [default: %default]')


if __name__ == "__main__":
    (options,args) = myparser.parse_args()
    if options.verbosity>= VERBOSE:
        print "verbosity = ", verbostiy
    for filename in args:
        if options.verbosity>=TRACE:
            print "FILENAME: ",filename
        segyfile = None
        try: 
            segyfile = Segy(filename,drivername=options.drv)
        except ValueError:
            # FIX: make this optional as to warn or actually fail
            print "ERROR: Failed to open ",filename
            if not options.warnOnly:
                sys.exit("  -w not specified.  QUITTING..")
            else:
                print "  will keep on going (-w specified)"
                continue

        # pull in the header.

        headerStr = segyfile.header.getTextFileBlock()
        if options.ebcdic:
            print "ebcdic 2 ascii"
            import ebcdic
            headerStr = ebcdic.EbcdicToAscii(headerStr)
        #else:
        print headerStr
        
