#!/usr/bin/env python
"""

Remove posts/tent poles/telephone poles from xyz ascii data.

If there is a bad datapoint in an area of an xyz grid that sticks up
above the rest, you can use this program to toss out those values.

     Copyright (C) 2005  Kurt Schwehr

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

$Id: xyzdespike.py,v 1.2 2005/09/08 23:59:59 schwehr Exp $

http://www.python.org/doc/lib/module-optparse.html

http://schwehr.org/software/segy-py/
"""

# These values end up in the pydoc web page
__version__ = '$Revision: 1.2 $' # See man ident
__date__ = '$Date: 2005/09/08 23:59:59 $' # FIX: pull out just the date
__author__ = 'Kurt Schwehr'
__credits__ = """Brian for getting me to finally write this script"""

import sqlite
import os
import sys

BOMBASTIC= 4
VERBOSE  = 3
TRACE    = 2
TERSE    = 1
ALWAYS   = 0


from optparse import OptionParser

vcvs = "$Revision: 1.2 $"
vcvs = vcvs[vcvs.find(':')+2:]
vcvs = vcvs[:vcvs.find('$')-1]
version_cvs = vcvs
del (vcvs) # stop polution


myparser = OptionParser(usage="%prog [options] file1.xyz file2.xyz file3.xyz",
                      version="%prog - "+version_cvs)
myparser.add_option('-o','--out-file',dest='outFile',default='out.xyz',
                    help='Where to write the results [default: %default]')

myparser.add_option('-x','--min-x',dest='minX',default=None, type='float',
                    help=' [default: %default]')
myparser.add_option('-X','--max-x',dest='maxX',default=None, type='float',
                    help=' [default: %default]')

myparser.add_option('-y','--min-y',dest='minY',default=None, type='float',
                    help=' [default: %default]')
myparser.add_option('-Y','--max-y',dest='maxY',default=None, type='float',
                    help=' [default: %default]')


myparser.add_option('-d','--depth-threshold',dest='depth',default=None, type='float',
                    help='Throw out data above this value if in the region [default: %default]')


myparser.add_option('-v',action="count",dest='verbosity',default=0,
                    help='how information to give.  Specify multiple times to increase verbosity')
myparser.add_option('--verbosity',dest='verbosity',type='int',
                    help='Specify verbosity.  Should be in the range of '
                    +str(ALWAYS)+'...'+str(BOMBASTIC)+' (None...Bombastic)')

if __name__ == "__main__":
    (options,args) = myparser.parse_args()

    if options.verbosity >= TRACE:
        print "Verbosity = ", options.verbosity

    if options.verbosity >= BOMBASTIC:
        print "options: \n",options
        print "args:    \n",args
    out = open(options.outFile,"w")


    minX = options.minX;
    maxX = options.maxX;
    minY = options.minY;
    maxY = options.maxY;

    if minX>maxX:
        sys.exit ("ERROR: maxX must be greater than minX");
    if minY>maxY:
        sys.exit ("ERROR: maxY must be greater than minY");


    for filename in args:
        if options.verbosity>=TRACE:
            print "FILENAME: ",filename
        lineno=0
        for line in open(filename).xreadlines():
            lineno += 1
            if lineno%100000==0:
                print lineno
                if options.verbosity>=BOMBASTIC:
                    print line,
                    x,y,z = line.split()
                    print 'num ',float(x),float(y),float(z), minX,maxX, minY,maxY
                    
            x,y,z = line.split()
            x = float(x); y = float(y)


            if minX<=x and x<=maxX and minY<=y and y<=maxY:
                if options.verbosity >= BOMBASTIC:
                    print "in the zone: ", line, 
                z = float(z)
                if not (z>options.depth):
                    out.write(line)
                else:
                    print "SKIPPED: ",line,
            else:
                out.write(line)

